//CQGNjNXEZ~i
//KEFPGAgݍ݃VXeJ
//t@C@stopwatch.v 
//user_blkŎgpXgbvEHb`Verilog|HDLLq
//Rs[ C:\home\seminar\cq_lab\user_blk
//C̕Kv͂܂
//

module stopwatch (
               // inputs:
                clk,
                reset_n,
                start,
                lap,
                stop,
                cmd,
               // outputs:
                data,
                start_int,
                lap_int,
                stop_int,
                time_1ms,
                time_10ms,
                time_100ms,
                time_1s,
                time_10s,
                led_a,
                led_b,
                led_c
             );
  input           clk;
  input           reset_n;
  input           start;
  input           lap;
  input           stop;
  input   [2:0]   cmd;
  output  [3:0]   data;
  output          start_int;
  output          lap_int;
  output          stop_int;
  output  [3:0]   time_1ms;
  output  [3:0]   time_10ms;
  output  [3:0]   time_100ms;
  output  [3:0]   time_1s;
  output  [3:0]   time_10s;
  output  [  7: 0]led_a;
  output  [  7: 0]led_b;
  output  [  7: 0]led_c;

  reg [  3: 0]    sample_cnt;
  wire    sample_sig;
  reg     [  3: 0] data_in_0_dff;
  reg     [  3: 0] data_in_1_dff;
  reg     [  3: 0] data_in_2_dff;
  reg              smp_data_in_0;
  reg              smp_data_in_1;
  reg              smp_data_in_2;
  reg     [  3: 0] data;
  reg     [  3: 0] edge_capture;
  wire             start_in;
  wire             lap_in;
  wire             stop_in;
  wire             clear_in;
  reg    [1:0]     start_dff;
  reg    [1:0]     stop_dff;
  reg    [1:0]     lap_dff;
  reg    [1:0]     clear_dff;
  reg              start_sig;
  reg              lap_sig;
  reg              stop_sig;
  wire              clear_sig;
  reg              CNT_EN;
  wire             init_sig;
  wire             base_en; 
  reg   [18:0]     count_base;
  wire   [3:0]     count_10us;
  wire   [3:0]     count_100us;
  wire   [3:0]     count_1ms;
  wire   [3:0]     count_10ms;
  wire   [3:0]     count_100ms;
  wire   [3:0]     count_1s;
  wire   [3:0]     count_10s;
  wire             count_10u_carry;
  wire             count_100u_carry;
  wire             count_1ms_carry;
  wire             count_10ms_carry;
  wire             count_100ms_carry;
  wire             count_1s_carry;
  wire             count_10s_carry;
  reg   [3:0]      time_1ms;
  reg   [3:0]      time_10ms;
  reg   [3:0]      time_100ms;
  reg   [3:0]      time_1s;
  reg   [3:0]      time_10s;
   
   
function [7:0] hex2led7seg;
input [3:0] hex_data;
input dot;      
begin
  case (hex_data)
    4'h0:hex2led7seg = {7'b0000001,!dot};
    4'h1:hex2led7seg = {7'b1001111,!dot};
    4'h2:hex2led7seg = {7'b0010010,!dot};
    4'h3:hex2led7seg = {7'b0000110,!dot};
    4'h4:hex2led7seg = {7'b1001100,!dot};
    4'h5:hex2led7seg = {7'b0100100,!dot};
    4'h6:hex2led7seg = {7'b0100000,!dot};
    4'h7:hex2led7seg = {7'b0001111,!dot};
    4'h8:hex2led7seg = {7'b0000000,!dot};
    4'h9:hex2led7seg = {7'b0000100,!dot};
    4'ha:hex2led7seg = {7'b0001000,!dot};
    4'hb:hex2led7seg = {7'b1100000,!dot};
    4'hc:hex2led7seg = {7'b1110010,!dot};
    4'hd:hex2led7seg = {7'b1000001,!dot};
    4'he:hex2led7seg = {7'b0110000,!dot};
    4'hf:hex2led7seg = {7'b0111000,!dot};
    default hex2led7seg = 8'b11111111;    
  endcase 
end
endfunction

// read data
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        data <= 4'b0111;
      else
        data <= {data[3],stop_dff[0],lap_dff[0],start_dff[0]};
        /*
        if (start_sig==1'b1)
          data <= 4'b1110;
        //else if (lap_sig==1'b1)
        //  data <= 4'b1101;
        else if (stop_sig==1'b1)
          data <= 4'b1011;
        else if (clear_sig==1'b1)
          data <= 4'b0111;
        else
          data <= {data[3],data[2],lap_dff[0],data[0]};
       */
   end
    
  always @(posedge clk or negedge reset_n)
    if (reset_n == 0)
      sample_cnt <= 4'h0;
    else
      sample_cnt <= sample_cnt + 4'h1;

  assign sample_sig = (sample_cnt[3:0]==4'b1111);


  always @(posedge clk or negedge reset_n)
     begin
      if (reset_n == 0)
        begin
          data_in_0_dff <= 4'b1111;
          data_in_1_dff <= 4'b1111;
          data_in_2_dff <= 4'b1111;
        end
      else
        if ( sample_sig==1'b1)
           begin
             data_in_0_dff <= {data_in_0_dff[2:0],start};
             data_in_1_dff <= {data_in_1_dff[2:0],lap};
             data_in_2_dff <= {data_in_2_dff[2:0],stop};
           end
        else
          begin
            data_in_0_dff <= data_in_0_dff ;
            data_in_1_dff <= data_in_1_dff ;
            data_in_2_dff <= data_in_2_dff ;
          end
     end
     

  always @(posedge clk or negedge reset_n)
     begin
      if (reset_n == 0)
        begin
          smp_data_in_0 <= 1'b1;
          smp_data_in_1 <= 1'b1;
          smp_data_in_2 <= 1'b1;
        end
      else       
        begin
          if (data_in_0_dff==4'b1111)
            smp_data_in_0 <= 1'b1;
          else
            smp_data_in_0 <= 1'b0; 
          if (data_in_1_dff==4'b1111)
            smp_data_in_1 <= 1'b1;
          else
            smp_data_in_1 <= 1'b0; 
          if (data_in_2_dff==4'b1111)
            smp_data_in_2 <= 1'b1;
          else
            smp_data_in_2 <= 1'b0;
        end // else: !if(reset_n == 0)
     end // always @ (posedge clk or negedge reset_n)

 //
 // input sig 
 //
   assign start_in = ((smp_data_in_0==1'b0)||(cmd[0]==1'b0))?1'b0:1'b1;
   assign lap_in =   ((smp_data_in_1==1'b0)||(cmd[1]==1'b0))?1'b0:1'b1;
   assign stop_in =  ((smp_data_in_2==1'b0)||(cmd[2]==1'b0))?1'b0:1'b1;

   
 always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        begin
          start_dff <= 2'b11;
          lap_dff <= 2'b11;
          stop_dff <= 2'b11;
          clear_dff <= 2'b11;
        end
      else
        begin
          start_dff <= {start_dff[0],start_in};
          lap_dff <= {lap_dff[0],lap_in};
          stop_dff <= {stop_dff[0],stop_in};
          clear_dff <= {clear_dff[0],clear_in};
        end // else: !if(reset_n == 0)
   end
           
 always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        start_sig <= 1'b0;
      else
        if (start_dff==2'b10)
          if (CNT_EN==1'b0)
            start_sig <= 1'b1;
          else
            start_sig <= 1'b0;
        else
          start_sig <= 1'b0; 
     end
   
 always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stop_sig <= 1'b0;
      else
        if (stop_dff==2'b10)
            if (CNT_EN==1'b1)
              stop_sig <= 1'b1;
            else
              stop_sig <= 1'b0;
        else
            stop_sig <= 1'b0;
    end

  assign start_int = start_sig;
  assign lap_int = lap_sig;
  assign stop_int = stop_sig;

always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        lap_sig <= 1'b0;
      else
        if (lap_dff==2'b10)
          lap_sig <= 1'b1;
        else
          lap_sig <= 1'b0; 
    end
  
   
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        CNT_EN <= 1'b0;    
      else
        if (start_sig == 1'b1)
          CNT_EN <= 1'b1;
        else
          if (stop_sig == 1'b1)    
            CNT_EN <= 1'b0;
          else     
            CNT_EN <= CNT_EN;
    end 
 //
 //counter
 //     
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        count_base <= 19'd0;
      else
        if (init_sig == 1'b1)
          count_base <= 19'd0;
        else
          if (CNT_EN== 1'b1)
            if ( base_en == 1'b1)  // 1us
              count_base <= 19'd0;
            else
              count_base <= count_base +19'd1;
          else
            count_base <= count_base ;
    end 

assign clear_sig = start_sig;   
assign init_sig = (clear_sig==1'b1)?1'b1:1'b0;
//assign base_en = ((count_base == 19'd499)&&(CNT_EN== 1'b1))?1'b1:1'b0; //10us clk=50MHz
assign base_en = ((count_base == 19'd329)&&(CNT_EN== 1'b1))?1'b1:1'b0; //10us clk=33MHz
//assign base_en = ((count_base == 19'd199)&&(CNT_EN== 1'b1))?1'b1:1'b0; //10us clk=20MHz

count_10 c_10u(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( base_en),
 .INIT   ( init_sig),
 .COUNT  ( count_10us),
 .CARRY  ( count_10u_carry)
);
   
count_10 c_100u(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_10u_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_100us),
 .CARRY  ( count_100u_carry)
);
   
count_10 c_1m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_100u_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_1ms),
 .CARRY  ( count_1ms_carry)
);
   
count_10 c_10m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_1ms_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_10ms),
 .CARRY  ( count_10ms_carry)
);

count_10 c_100m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_10ms_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_100ms),
 .CARRY  ( count_100ms_carry)
);

count_10 c_1s(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_100ms_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_1s),
 .CARRY  ( count_1s_carry)
);

count_10 c_10s(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_1s_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_10s),
 .CARRY  ( count_10s_carry)
);
  
assign led_a =hex2led7seg(count_100ms,1'b0);
assign led_b =hex2led7seg(count_1s,1'b1);
assign led_c =hex2led7seg(count_10s,1'b0);
   
   // read data
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        begin
           time_1ms   <= 4'h0;
           time_10ms  <= 4'h0;
           time_100ms <= 4'h0;
           time_1s   <= 4'h0;
           time_10s  <= 4'h0;
        end
      else
        if ((stop_sig==1'b1)||(lap_sig==1'b1))
        begin
           time_1ms   <= count_1ms ;
           time_10ms   <= count_10ms ;
           time_100ms   <= count_100ms ;
           time_1s   <= count_1s ;
           time_10s   <= count_10s ;
        end 
    end

 
 
endmodule

