//CQGNjNXEZ~i
//KEFPGAgݍ݃VXeJ
//t@C@user_blk.v 
//U[H{
//Rs[ C:\home\seminar\cq_lab\user_blk\m-sim
//KEŏCĊ܂
//
module user_blk (
               // inputs:
                clk,
                reset_n,
                address,
                chipselect,
                in_port,
                write_n,
                writedata,
               // outputs:
                irq,
                readdata,
                led_a,
                led_b,
                led_c
             );

  input            clk;
  input            reset_n;
  input   [  5: 0] address;
  input            chipselect;
  input   [  2: 0] in_port;
  input            write_n;
  input   [  7: 0] writedata;
  output           irq;
  output  [  7: 0] readdata;
  output  [  7: 0]led_a;
  output  [  7: 0]led_b;
  output  [  7: 0]led_c;

  reg     [  7: 0] cmd;
  wire    [  3: 0] data;
  reg     [  3: 0] edge_capture;
  wire             edge_capture_wr_strobe;
  wire    [  3: 0] edge_detect;
  wire             irq;
  reg     [  3: 0] irq_mask;
  wire    [  7: 0] read_mux_out;
  reg     [  7: 0] readdata;

  wire             start;
  wire             lap;
  wire             stop;
  wire             start_int;
  wire             lap_int;
  wire             stop_int;
  wire             clear_int;
  wire   [3:0]      time_1ms;
  wire   [3:0]      time_10ms;
  wire   [3:0]      time_100ms;
  wire   [3:0]      time_1s;
  wire   [3:0]      time_10s;
   
 //input signal
  assign start = in_port[0];
  assign lap   = in_port[1];
  assign stop  = in_port[2];
 
 // irq_mak
 //irg_maskWX^LqĂB
  always @(posedge clk or negedge reset_n)
    begin
       
    end

   
 // irq  
  assign irq = |(edge_capture & irq_mask);

  assign edge_capture_wr_strobe = chipselect && ~write_n && (address == 12);

  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[0] <= 0;
      else
        if (edge_capture_wr_strobe)
            edge_capture[0] <= 0;
        else if (edge_detect[0])
            edge_capture[0] <= -1;
    end

  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[1] <= 0;
      else
        if (edge_capture_wr_strobe)
            edge_capture[1] <= 0;
        else if (edge_detect[1])
            edge_capture[1] <= -1;
    end

  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[2] <= 0;
      else
        if (edge_capture_wr_strobe)
            edge_capture[2] <= 0;
        else if (edge_detect[2])
            edge_capture[2] <= -1;
    end

  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[3] <= 0;
      else
        if (edge_capture_wr_strobe)
            edge_capture[3] <= 0;
        else if (edge_detect[3])
            edge_capture[3] <= -1;
    end
   
  assign clear_int = 1'b0; 
  assign edge_detect = {clear_int,lap_int,stop_int,start_int};
   
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cmd <= 255;
      else if (chipselect && ~write_n && (address == 16))
          cmd <= writedata[7 : 0];
    end
   
  assign read_mux_out = (address == 6'h00)?{4'b0000,data}:
                        //Ƀ[hpf[^ILqĂB
                        //
                        (address == 6'h38)?{4'h0, time_10s}:8'h00;
 
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          readdata <= 0;
      else
          readdata <=read_mux_out;
    end
  

stopwatch stopwatch(
// inputs:
.clk(         clk),           
.reset_n(     reset_n),     
.start(       start),         
.lap(         lap),           
.stop(        stop),          
.cmd(         cmd),           
// outputs:   / outputs:   
.data(        data),      
.start_int(   start_int),         
.lap_int(     lap_int),           
.stop_int(    stop_int),          
.time_1ms(    time_1ms),   
.time_10ms(   time_10ms),  
.time_100ms(  time_100ms), 
.time_1s(     time_1s),    
.time_10s(    time_10s),   
.led_a(       led_a),         
.led_b(       led_b),         
.led_c(       led_c)        
             );
endmodule

