`timescale 1 ns/10 ps
//CQGNjNXEZ~i
//KEFPGAgݍ݃VXeJ
//t@C@user_blk_test.v 
//U[H{̂̃eXgx`
//Rs[ C:\home\seminar\cq_lab\user_blk\m-sim
//KEŏCĊ܂
//
module user_blk_test ;

  reg            clk;         
  reg            reset_n;     
  reg   [  5: 0] address;     
  reg            chipselect;  
  reg   [  2: 0] in_port;     
  reg            write_n;     
  reg   [  7: 0] writedata;   
  wire           irq;         
  wire  [  7: 0] readdata;    
  wire  [  7: 0] led_a;       
  wire  [  7: 0] led_b;       
  wire  [  7: 0] led_c;       

  parameter CYCLE = 30;  // 30ns 30MHz
   
user_blk dut(
  .clk(         clk),                 
  .reset_n(     reset_n),     
  .address(     address),     
  .chipselect(  chipselect),  
  .in_port(     in_port),     
  .write_n(     write_n),     
  .writedata(   writedata),   
  .irq(         irq),                   
  .readdata(    readdata),      
  .led_a(       led_a),         
  .led_b(       led_b),        
  .led_c(       led_c));
  

 task t_write;
   input [5:0] add;
   input [7:0]  in_data;
   begin
     address <= add;
     chipselect <= 1'b0;
     write_n <= 1'b1;
     writedata <= in_data;      
     #(CYCLE);
     chipselect <= 1'b1;
     write_n <= 1'b0;   
     #(CYCLE);
     chipselect <= 1'b0;
     write_n <= 1'b1;
  end
 endtask // t_write
   
 task t_read;
   input [5:0] add;
   begin
     address <= add;
     chipselect <= 1'b0;
     write_n <= 1'b1;     
     #(CYCLE);
     chipselect <= 1'b1;
     #(CYCLE);
     chipselect <= 1'b0;
  end
 endtask // t_read
   
initial
  begin
    repeat(80000000)
    begin
      clk <= 1'b0;
      #(CYCLE/2);
      clk <= 1'b1;
      #(CYCLE/2);
    end
  end   

initial
  begin
    reset_n <= 1'b0;  
    address <= 6'h00; 
    chipselect <= 1'b0;
    in_port <= 4'b1111; 
    write_n <= 1'b1;     
    writedata <= 8'h00;   
    #(CYCLE*10);
    reset_n  <= 1'b1;
    #(CYCLE*10);
    t_read(6'h00);
    #(CYCLE*10);
    t_read(6'h08);
    #(CYCLE*10);
    t_write(6'h08,8'h07);
    #(CYCLE*10);
    t_read(6'h08);
    #(CYCLE*10);
    in_port <= 4'b1110; 
    #(CYCLE*1000);
    t_read(6'h00);
    #(CYCLE*1000);
    in_port <= 4'b1111; 
    #(CYCLE*1000);
    in_port <= 4'b1011; 
    #(CYCLE*1000);
    t_read(6'h00);
    #(CYCLE*1000);
    in_port <= 4'b1111; 
    #(CYCLE*10);
    t_read(6'h28);
    t_read(6'h2c);
    t_read(6'h30);
    t_read(6'h34);
    t_read(6'h38);
    $stop; 
  end
     

endmodule

